<?php
/**
 * TOP API: ecs.aliyuncs.com.DescribeInstances.2014-05-26 request
 * 
 * @author auto create
 * @since 1.0, 2015.07.13
 */
class Ecs20140526DescribeInstancesRequest
{
	/** 
	 * 实例内网ip地址（classic），最多不超过10个，实例网络类型（InstanceNetworkType）为classic时生效，否则忽略。
	 **/
	private $innerIpAddresses;
	
	/** 
	 * 最多不超过10个。
	 **/
	private $instanceIds;
	
	/** 
	 * 实例网络类型
	 **/
	private $instanceNetworkType;
	
	/** 
	 * 实例状态列表的页码，起始值为1，默认值为1
	 **/
	private $pageNumber;
	
	/** 
	 * 分页查询时设置的每页行数，最大值50行，默认为10
	 **/
	private $pageSize;
	
	/** 
	 * 实例私网ip地址（vpc），最多不超过10个，实例网络类型（InstanceNetworkType）为vpc时生效，否则忽略。
	 **/
	private $privateIpAddresses;
	
	/** 
	 * 实例公网ip地址，最多不超过10个
	 **/
	private $publicIpAddresses;
	
	/** 
	 * 区域Id
	 **/
	private $regionId;
	
	/** 
	 * 安全组Id
	 **/
	private $securityGroupId;
	
	/** 
	 * 虚拟交换机Id
	 **/
	private $vSwitchId;
	
	/** 
	 * 虚拟专有网络Id
	 **/
	private $vpcId;
	
	/** 
	 * 可用区Id
	 **/
	private $zoneId;
	
	/**
	 * 仅用于渠道商发起API调用时，指定访问的资源拥有者的ID
	 **/
	private $ownerId;
	
	/**
	 *仅用于渠道商发起API调用时，指定访问的资源拥有者的账号
	 **/
    private  $ownerAccount;
    
    /**
     *API调用者试图通过API调用来访问别人拥有但已经授权给他的资源时，
     *通过使用该参数来声明此次操作涉及到的资源是谁名下的,该参数仅官网用户可用
     **/
    private $resourceOwnerAccount;
    
	private $apiParas = array();
	
	public function setInnerIpAddresses($innerIpAddresses)
	{
		$this->innerIpAddresses = $innerIpAddresses;
		$this->apiParas["InnerIpAddresses"] = $innerIpAddresses;
	}

	public function getInnerIpAddresses()
	{
		return $this->innerIpAddresses;
	}

	public function setInstanceIds($instanceIds)
	{
		$this->instanceIds = $instanceIds;
		$this->apiParas["InstanceIds"] = $instanceIds;
	}

	public function getInstanceIds()
	{
		return $this->instanceIds;
	}

	public function setInstanceNetworkType($instanceNetworkType)
	{
		$this->instanceNetworkType = $instanceNetworkType;
		$this->apiParas["InstanceNetworkType"] = $instanceNetworkType;
	}

	public function getInstanceNetworkType()
	{
		return $this->instanceNetworkType;
	}

	public function setPageNumber($pageNumber)
	{
		$this->pageNumber = $pageNumber;
		$this->apiParas["PageNumber"] = $pageNumber;
	}

	public function getPageNumber()
	{
		return $this->pageNumber;
	}

	public function setPageSize($pageSize)
	{
		$this->pageSize = $pageSize;
		$this->apiParas["PageSize"] = $pageSize;
	}

	public function getPageSize()
	{
		return $this->pageSize;
	}

	public function setPrivateIpAddresses($privateIpAddresses)
	{
		$this->privateIpAddresses = $privateIpAddresses;
		$this->apiParas["PrivateIpAddresses"] = $privateIpAddresses;
	}

	public function getPrivateIpAddresses()
	{
		return $this->privateIpAddresses;
	}

	public function setPublicIpAddresses($publicIpAddresses)
	{
		$this->publicIpAddresses = $publicIpAddresses;
		$this->apiParas["PublicIpAddresses"] = $publicIpAddresses;
	}

	public function getPublicIpAddresses()
	{
		return $this->publicIpAddresses;
	}

	public function setRegionId($regionId)
	{
		$this->regionId = $regionId;
		$this->apiParas["RegionId"] = $regionId;
	}

	public function getRegionId()
	{
		return $this->regionId;
	}

	public function setSecurityGroupId($securityGroupId)
	{
		$this->securityGroupId = $securityGroupId;
		$this->apiParas["SecurityGroupId"] = $securityGroupId;
	}

	public function getSecurityGroupId()
	{
		return $this->securityGroupId;
	}

	public function setvSwitchId($vSwitchId)
	{
		$this->vSwitchId = $vSwitchId;
		$this->apiParas["VSwitchId"] = $vSwitchId;
	}

	public function getvSwitchId()
	{
		return $this->vSwitchId;
	}

	public function setVpcId($vpcId)
	{
		$this->vpcId = $vpcId;
		$this->apiParas["VpcId"] = $vpcId;
	}

	public function getVpcId()
	{
		return $this->vpcId;
	}

	public function setZoneId($zoneId)
	{
		$this->zoneId = $zoneId;
		$this->apiParas["ZoneId"] = $zoneId;
	}

	public function getZoneId()
	{
		return $this->zoneId;
	}

	
	public function setOwnerId($ownerId)
	{
		$this->ownerId = $ownerId;
		$this->apiParas["OwnerId"] = $ownerId;
	}
	
	public function getOwnerId()
	{
		return $this->ownerId;
	}
	
	public function setOwnerAccount($ownerAccount)
	{
		$this->ownerAccount = $ownerAccount;
		$this->apiParas["OwnerAccount"] = $ownerAccount;
	}
	
	public function getOwnerAccount()
	{
		return $this->ownerAccount;
	}
	
	public function setResourceOwnerAccount($resourceOwnerAccount)
	{
		$this->resourceOwnerAccount = $resourceOwnerAccount;
		$this->apiParas["ResourceOwnerAccount"] = $resourceOwnerAccount;
	}
	
	public function getResourceOwnerAccount()
	{
		return $this->resourceOwnerAccount;
	}

	public function getApiMethodName()
	{
		return "ecs.aliyuncs.com.DescribeInstances.2014-05-26";
	}
	
	public function getApiParas()
	{
		return $this->apiParas;
	}
	
	public function check()
	{
		
		RequestCheckUtil::checkMaxValue($this->pageSize,50,"pageSize");
		RequestCheckUtil::checkNotNull($this->regionId,"regionId");
	}
	
	public function putOtherTextParam($key, $value) {
		$this->apiParas[$key] = $value;
		$this->$key = $value;
	}
}